import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualNodeSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate {
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch {
    /**
     * @stability stable
     */
    readonly exact: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm {
    /**
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm[];
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames[];
    /**
     * trust block.
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls {
    /**
     * @stability stable
     */
    readonly enforce?: boolean;
    /**
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * certificate block.
     *
     * @stability stable
     */
    readonly certificate?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate[];
    /**
     * validation block.
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy {
    /**
     * tls block.
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualService {
    /**
     * @stability stable
     */
    readonly virtualServiceName: string;
    /**
     * client_policy block.
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackend {
    /**
     * virtual_service block.
     *
     * @stability stable
     */
    readonly virtualService: AppmeshVirtualNodeSpecBackendVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate {
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch {
    /**
     * @stability stable
     */
    readonly exact: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
    /**
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm[];
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames[];
    /**
     * trust block.
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls {
    /**
     * @stability stable
     */
    readonly enforce?: boolean;
    /**
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * certificate block.
     *
     * @stability stable
     */
    readonly certificate?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate[];
    /**
     * validation block.
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicy {
    /**
     * tls block.
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaults {
    /**
     * client_policy block.
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolGrpc {
    /**
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp {
    /**
     * @stability stable
     */
    readonly maxConnections: number;
    /**
     * @stability stable
     */
    readonly maxPendingRequests?: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 {
    /**
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolTcp {
    /**
     * @stability stable
     */
    readonly maxConnections: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPool {
    /**
     * grpc block.
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc[];
    /**
     * http block.
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp[];
    /**
     * http2 block.
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2[];
    /**
     * tcp block.
     *
     * @stability stable
     */
    readonly tcp?: AppmeshVirtualNodeSpecListenerConnectionPoolTcp[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerHealthCheck {
    /**
     * @stability stable
     */
    readonly healthyThreshold: number;
    /**
     * @stability stable
     */
    readonly intervalMillis: number;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly timeoutMillis: number;
    /**
     * @stability stable
     */
    readonly unhealthyThreshold: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetectionInterval {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetection {
    /**
     * @stability stable
     */
    readonly maxEjectionPercent: number;
    /**
     * @stability stable
     */
    readonly maxServerErrors: number;
    /**
     * base_ejection_duration block.
     *
     * @stability stable
     */
    readonly baseEjectionDuration: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration[];
    /**
     * interval block.
     *
     * @stability stable
     */
    readonly interval: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerPortMapping {
    /**
     * @stability stable
     */
    readonly port: number;
    /**
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpc {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttpIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2 {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutTcpIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutTcp {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeout {
    /**
     * grpc block.
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualNodeSpecListenerTimeoutGrpc[];
    /**
     * http block.
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualNodeSpecListenerTimeoutHttp[];
    /**
     * http2 block.
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualNodeSpecListenerTimeoutHttp2[];
    /**
     * tcp block.
     *
     * @stability stable
     */
    readonly tcp?: AppmeshVirtualNodeSpecListenerTimeoutTcp[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateAcm {
    /**
     * @stability stable
     */
    readonly certificateArn: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificate {
    /**
     * acm block.
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecListenerTlsCertificateAcm[];
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecListenerTlsCertificateFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecListenerTlsCertificateSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch {
    /**
     * @stability stable
     */
    readonly exact: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrustFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrustSds {
    /**
     * @stability stable
     */
    readonly secretName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrust {
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile[];
    /**
     * sds block.
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames[];
    /**
     * trust block.
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecListenerTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTls {
    /**
     * @stability stable
     */
    readonly mode: string;
    /**
     * certificate block.
     *
     * @stability stable
     */
    readonly certificate: AppmeshVirtualNodeSpecListenerTlsCertificate[];
    /**
     * validation block.
     *
     * @stability stable
     */
    readonly validation?: AppmeshVirtualNodeSpecListenerTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListener {
    /**
     * connection_pool block.
     *
     * @stability stable
     */
    readonly connectionPool?: AppmeshVirtualNodeSpecListenerConnectionPool[];
    /**
     * health_check block.
     *
     * @stability stable
     */
    readonly healthCheck?: AppmeshVirtualNodeSpecListenerHealthCheck[];
    /**
     * outlier_detection block.
     *
     * @stability stable
     */
    readonly outlierDetection?: AppmeshVirtualNodeSpecListenerOutlierDetection[];
    /**
     * port_mapping block.
     *
     * @stability stable
     */
    readonly portMapping: AppmeshVirtualNodeSpecListenerPortMapping[];
    /**
     * timeout block.
     *
     * @stability stable
     */
    readonly timeout?: AppmeshVirtualNodeSpecListenerTimeout[];
    /**
     * tls block.
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecListenerTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLoggingAccessLogFile {
    /**
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLoggingAccessLog {
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecLoggingAccessLogFile[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLogging {
    /**
     * access_log block.
     *
     * @stability stable
     */
    readonly accessLog?: AppmeshVirtualNodeSpecLoggingAccessLog[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap {
    /**
     * @stability stable
     */
    readonly attributes?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly namespaceName: string;
    /**
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscoveryDns {
    /**
     * @stability stable
     */
    readonly hostname: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscovery {
    /**
     * aws_cloud_map block.
     *
     * @stability stable
     */
    readonly awsCloudMap?: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap[];
    /**
     * dns block.
     *
     * @stability stable
     */
    readonly dns?: AppmeshVirtualNodeSpecServiceDiscoveryDns[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpec {
    /**
     * backend block.
     *
     * @stability stable
     */
    readonly backend?: AppmeshVirtualNodeSpecBackend[];
    /**
     * backend_defaults block.
     *
     * @stability stable
     */
    readonly backendDefaults?: AppmeshVirtualNodeSpecBackendDefaults[];
    /**
     * listener block.
     *
     * @stability stable
     */
    readonly listener?: AppmeshVirtualNodeSpecListener[];
    /**
     * logging block.
     *
     * @stability stable
     */
    readonly logging?: AppmeshVirtualNodeSpecLogging[];
    /**
     * service_discovery block.
     *
     * @stability stable
     */
    readonly serviceDiscovery?: AppmeshVirtualNodeSpecServiceDiscovery[];
}
/**
 * @stability stable
 */
export declare class AppmeshVirtualNode extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualNodeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualNodeSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshVirtualNodeSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualNodeSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
