import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayUploadBufferConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly diskId?: string;
    /**
     * @stability stable
     */
    readonly diskPath?: string;
    /**
     * @stability stable
     */
    readonly gatewayArn: string;
}
/**
 * @stability stable
 */
export declare class StoragegatewayUploadBuffer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayUploadBufferConfig);
    private _diskId?;
    /**
     * @stability stable
     */
    get diskId(): string;
    /**
     * @stability stable
     */
    set diskId(value: string);
    /**
     * @stability stable
     */
    resetDiskId(): void;
    /**
     * @stability stable
     */
    get diskIdInput(): string | undefined;
    private _diskPath?;
    /**
     * @stability stable
     */
    get diskPath(): string;
    /**
     * @stability stable
     */
    set diskPath(value: string);
    /**
     * @stability stable
     */
    resetDiskPath(): void;
    /**
     * @stability stable
     */
    get diskPathInput(): string | undefined;
    private _gatewayArn;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
